package com.brilliance.eibs.server;

import com.brilliance.eibs.core.model.IServiceDef;
import com.brilliance.eibs.core.service.Context;
import com.brilliance.eibs.el.ApacheEL;
import com.brilliance.eibs.main.Client;
import com.brilliance.eibs.util.LogUtil;
import org.slf4j.Logger;

/**
 * @author hujun
 *
 *         初始化“服务”，用于需要初次加载的内容， 比如长连接用于首先向对方发起请求，建立链路
 */
public class InitServer extends AbsServer {

	public InitServer(Context context, IServiceDef serviceDef, ApacheEL elParser) {
		super(context, serviceDef, elParser);
	}

	@Override
	public void run() {
		logger.info( LOG_FLAG + "InitServer starting ." + LOG_FLAG);
		final String interfaceName = getRequiredPropertyValue("interfaceName");
		final String transName = getRequiredPropertyValue("transactionName");
		/*
		 * new Thread(new Runnable() {
		 * 
		 * @Override public void run() {
		 */

		new Client().call(interfaceName, transName, null);
		/*
		 * } }).start();
		 */

		logger.info( LOG_FLAG + "InitServer is finished." + LOG_FLAG);
	}

	@Override
	public void close() {
		// nothing to do
		// not nessesary
	}

	public void call(String interfaceName, String transName) {
		/*
		 * try { CommonUtil.sleep(10000); } catch (InterruptedException
		 * e) { // TODO Auto-generated catch block e.printStackTrace(); }
		 */

		Logger log = LogUtil.getTrnLog(interfaceName, transName);
		// log.info("init....");
		new Client().call(interfaceName, transName, null, log);
	}

}
