package com.brilliance.eibs.server;

import com.brilliance.eibs.core.exception.InterfaceException;
import com.brilliance.eibs.core.model.IServiceDef;
import com.brilliance.eibs.core.service.Context;
import com.brilliance.eibs.el.ApacheEL;
import com.brilliance.snmp.server.SnmpEngine;

/**
 * SnmpServer
 *
 * @author gechengyang
 */
public class SnmpServer extends AbsServer {

    private org.eclipse.jetty.server.Server server;

    public SnmpServer(Context context, IServiceDef serviceDef, ApacheEL elParser) {
        super(context, serviceDef, elParser);
    }

    @Override
    public void run() {
        logger.info(LOG_FLAG + "starting SnmpService[id:" + serviceDef.getId() + "]." + LOG_FLAG);
        try {
            String adress = getRequiredPropertyValue("url");
            String timer = getRequiredPropertyValue("time");
            int time = Integer.parseInt(timer);
            String oids = getRequiredPropertyValue("oids");
            String interfaceName = getRequiredPropertyValue("interfaceName");
            String transactionName = getRequiredPropertyValue("transactionName");

            SnmpEngine engine = new SnmpEngine(adress, time, oids, interfaceName, transactionName, logger);
            engine.run();
        } catch (Exception e) {
            e.printStackTrace();
            new InterfaceException("05001", e);
        }
        logger.info(LOG_FLAG + "SnmpService[id:" + serviceDef.getId() + "] is started." + LOG_FLAG);
    }

    @Override
    public void close() {
        if (server != null)
            try {
                server.stop();
            } catch (Exception e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        // server.destroy();
    }
}
