package com.brilliance.eibs.el;

import com.brilliance.eibs.util.ByteUtil;
import com.brilliance.eibs.util.DateUtil;
import com.brilliance.eibs.util.NumberUtil;
import com.google.gson.Gson;
import org.apache.commons.lang.time.DateUtils;

import javax.xml.datatype.XMLGregorianCalendar;
import java.io.File;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.URLDecoder;
import java.text.ParseException;
import java.util.Date;

/**
 * @Description
 * @Author s_guodong
 * @Date 2022/6/30
 */
public class CommonUtil {

    public static String decodeURL(String path) {
        try {
            return URLDecoder.decode(path, "UTF-8");
        } catch (UnsupportedEncodingException e) {
        }
        return null;
    }

    public static URL getCommonURL(String relativePath) {
        URL url = Thread.currentThread().getContextClassLoader()
                .getResource(relativePath);
        if (url == null) {
            url = CommonUtil.class.getClassLoader().getResource(
                    relativePath);
            if (url == null) {
                url = CommonUtil.class.getClassLoader()
                        .getResource("");
                try {
                    return new URL(url + relativePath);
                } catch (MalformedURLException e) {
                }
            }
        }
        return url;
    }


    public static final Date dateAdd(Date paramDate, int paramInt1,
                                     int paramInt2) {
        return DateUtil.dateAdd(paramDate, paramInt1, paramInt2);
    }

    public static Date parseDate(Date date, String parsePattern)
            throws ParseException {
        return DateUtil.parseDate(date, parsePattern);
    }

    public static Date parseDate(String date, String parsePattern)
            throws ParseException {
        return DateUtils.parseDate(date, new String[] { parsePattern });
    }

    public static String formatNow() {
        return DateUtil.formatNow();
    }

    public static String formatNow(String pattern) {
        return DateUtil.formatNow(pattern);
    }

    public static String format(Date date) {
        return DateUtil.format(date);
    }

    public static String format(Date date, String pattern) {
        return DateUtil.format(date, pattern);
    }

    public static String format(XMLGregorianCalendar xgc, String pattern) {
        return DateUtil.format(xgc, pattern);
    }

    public static byte[] intToBytes(int i, int flg) {
        return ByteUtil.intToBytes(i, flg);
    }

    public static byte[] intToBytes(int i) {
        return ByteUtil.intToBytes(i);
    }

    public static int bytesToInt(byte[] bytes) {
        return ByteUtil.bytesToInt(bytes);
    }

    public static String decimalFormat2(Object decimal, int num) {
        if (decimal == null || ((decimal instanceof String) && (decimal.toString().trim().equals("")))) {
            decimal = "0";
        }
        return decimalFormat(decimal, num);
    }


    public static String decimalFormat(Object decimal, int num) {
        return NumberUtil.decimalFormat(decimal, num);
    }

    public static byte[] parseHexStr2Byte(String hexStr) {
        return ByteUtil.parseHexStr2Byte(hexStr);
    }

    public static String toJson(Object obj) {
        return new Gson().toJson(obj);
    }

    /**
     * 判断给定路径下的文件是否存在
     *
     * @return 存在返回文件路径，否则返回空
     */
    public static String getFilePath(String filepth) {
        File f = null;
        try {
            f = new File(getCommonURL(filepth).toURI());
        } catch (URISyntaxException e) {
            return null;
        }
        return f == null ? null : f.exists() ? f.getPath() : null;
    }
}
